"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const toggle_1 = __importDefault(require("../toggle"));
const view_1 = __importDefault(require("../view"));
const edit_1 = __importDefault(require("../edit"));
const delete_1 = __importDefault(require("../delete"));
const w_loader_1 = __importDefault(require("../w-loader"));
const Detail = (Form, viewFields, { update, detail, deleteById, getOptions }, redirectUrl, showToggle = true) => {
    // merge different promises to have all in the same functions
    const detailWOptions = async (id) => {
        const data = await detail(id);
        const options = getOptions
            ? await getOptions()
            : new Map();
        return { data, options };
    };
    const Delete = deleteById
        ? delete_1.default(deleteById, redirectUrl)
        : () => react_1.default.createElement(react_1.default.Fragment, null);
    // define final view based on options chosen
    const Main = getMain(showToggle, viewFields, Form, redirectUrl, update);
    getOptions && getOptions();
    const EditLoader = ({ id }) => w_loader_1.default({
        Component: ({ data, }) => react_1.default.createElement(Main, { id: id, data: data.data, formOptions: data.options }),
        getData: () => detailWOptions(id),
    });
    return ({ id }) => (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(EditLoader, { id: id }),
        "\u00A0",
        react_1.default.createElement(Delete, { id: id })));
};
const getMain = (showToggle, viewFields, Form, redirectUrl, update) => {
    const View = view_1.default(viewFields);
    if (!update) {
        return View;
    }
    const Edit = edit_1.default(Form, update, redirectUrl);
    if (showToggle) {
        return toggle_1.default(Edit, View);
    }
    return Edit;
};
exports.default = Detail;
