"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const Form = (FormUI) => ({ valueDefault = {}, onSuccess }) => {
    const [data, setData] = react_1.default.useState(valueDefault);
    const [loading, setLoading] = react_1.default.useState(false);
    const onChange = (v, name) => {
        setData({ ...data, [name]: v });
    };
    const handleSubmit = (e) => {
        e.preventDefault();
        setLoading(true);
        onSuccess(data);
    };
    return (react_1.default.createElement("form", { onSubmit: handleSubmit },
        react_1.default.createElement(FormUI, { disabled: loading, data: data, onChange: onChange }),
        react_1.default.createElement("button", { className: "btn btn-sm btn-primary", disabled: loading, type: "submit" }, "Submit")));
};
exports.default = Form;
