"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const V = __importStar(require("@nexys/validation"));
const U = __importStar(require("./utils"));
const FormGenerator = (Wrapper, FormUnit, BtnSubmit) => ({ formDef, onSuccess, isLoading = false, valueDefault = {}, errors: errorsDefault, }) => {
    const [data, setData] = react_1.default.useState(valueDefault);
    const [errors, setErrors] = react_1.default.useState(errorsDefault);
    react_1.default.useEffect(() => {
        setErrors(errorsDefault);
    }, [errorsDefault]);
    const validator = U.generateValidatorFromDef(formDef);
    // console.log(validator);
    // console.log(JSON.stringify(data));
    const handleSubmit = (event) => {
        event.preventDefault();
        const v = V.Main.checkObject(data, validator);
        // console.log(v);
        setErrors(v);
        // no errors found
        if (Object.values(v).length === 0) {
            //
            //alert(JSON.stringify(v));
            onSuccess(data);
        }
    };
    //console.log({ errors });
    return (react_1.default.createElement("form", { onSubmit: handleSubmit },
        formDef.map((fd, i) => {
            const name = fd.name;
            const errorUnit = errors && errors[name];
            //console.log(name, errorUnit);
            return (react_1.default.createElement(Wrapper, { errors: errorUnit, key: i, label: fd.label },
                react_1.default.createElement(FormUnit, { type: fd.uiType, errors: errorUnit, value: data[fd.name], onChange: (v) => setData({ ...data, [fd.name]: v }), options: fd.options, disabled: isLoading })));
        }),
        react_1.default.createElement(BtnSubmit, { isLoading: isLoading })));
};
exports.default = FormGenerator;
