/// <reference types="react" />
/**
 *
 * @param Loader
 * @param nullPlaceholder  this is to avoid the following scenario: promise returns an actuall `null` and hence component is stuck in infinite loop. Hence the dev can pick any value. We recommend "null". In some scenarios it might be beneficial to pick `undefined` or `null`
 * @returns
 */
export declare const WLoader: <NullType extends string>(Loader: (props: any) => JSX.Element, nullPlaceholder?: NullType) => <T>({ getData, Component, }: {
    getData: () => Promise<T>;
    Component: ({ data }: {
        data: T;
    }) => JSX.Element;
}) => JSX.Element;
export default WLoader;
