"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WLoader = void 0;
const react_1 = __importDefault(require("react"));
const utils_1 = require("./utils");
/**
 *
 * @param Loader
 * @param nullPlaceholder  this is to avoid the following scenario: promise returns an actuall `null` and hence component is stuck in infinite loop. Hence the dev can pick any value. We recommend "null". In some scenarios it might be beneficial to pick `undefined` or `null`
 * @returns
 */
const WLoader = (Loader, nullPlaceholder = "null") => ({ getData, Component, }) => {
    const [data, setData] = react_1.default.useState(nullPlaceholder);
    if (utils_1.isNullType(data, nullPlaceholder)) {
        return react_1.default.createElement(Component, { data: data });
    }
    getData().then(setData);
    return react_1.default.createElement(Loader, null);
};
exports.WLoader = WLoader;
exports.default = exports.WLoader;
